using System;
using Microsoft.Xrm.Sdk;

namespace OrbitOne.CRMLyncInfoDashboard.CRM.Plugins
{
    /// <summary>
    /// Please remember to sign this project with a strong name!
    /// 
    /// Message:    Create
    /// Stage:      Pre
    /// Mode:       Synchronous
    /// Entity:     account
    /// </summary>
    public class SamplePlugin : IPlugin
    {
        public void Execute(IServiceProvider serviceProvider)
        {
            var context = (IPluginExecutionContext)serviceProvider.GetService(typeof(IPluginExecutionContext));

            var factory = (IOrganizationServiceFactory)serviceProvider.GetService(typeof(IOrganizationServiceFactory));
            var sdk = factory.CreateOrganizationService(context.UserId);
            var tracer = (ITracingService)serviceProvider.GetService(typeof(ITracingService));

            if (context.Depth != 1) { return; }

			if (context.Stage == MessageProcessingStage.PreOperation) { }

			if (context.Mode == MessageProcessingMode.Synchronous) { }

            if (context.InputParameters.Contains("Target") && context.InputParameters["Target"] is Entity)
            {
                var tempEntity = context.InputParameters["Target"] as Entity;

                ISearchFieldProviderFactory searchFieldProviderFactory = new SearchFieldProviderFactory();
                var searchFieldProvider = searchFieldProviderFactory.Get(tempEntity.LogicalName, sdk);

                if (searchFieldProvider == null) return;
                var calculateSearchFieldValue = searchFieldProvider.CalculateSearchFieldValue(tempEntity, context);
                tempEntity["orb_lyncsearchfield"] = calculateSearchFieldValue;
            }
        }
    }
}
