﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text.RegularExpressions;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace OrbitOne.CRMLyncInfoDashboard.Shell
{
    public partial class App : Application
    {

        public App()
        {
            this.Exit += this.Application_Exit;
            this.UnhandledException += this.Application_UnhandledException;
            this.Startup += App_Startup;
            InitializeComponent();
        }

        void App_Startup(object sender, StartupEventArgs e)
        {
            Current.Resources.Add("Debug", e.InitParams["debug"]);
            Current.Resources.Add("Regex", new Regex(e.InitParams["regex"]));
            Current.Resources.Add("AccountLyncSearchField", e.InitParams["accountLyncSearchField"]);
            Current.Resources.Add("ContactLyncSearchField", e.InitParams["contactLyncSearchField"]);
            Current.Resources.Add("LeadLyncSearchField", e.InitParams["leadLyncSearchField"]);
            Current.Resources.Add("NewEntityUrlPattern", e.InitParams["newEntityUrlPattern"]);
            Current.Resources.Add("EditEntityUrlPattern", e.InitParams["editEntityUrlPattern"]);
            Current.Resources.Add("NewNoteUrlPattern", e.InitParams["newNoteUrlPattern"]);
        }

        private void Application_Exit(object sender, EventArgs e)
        {
           
        }

        private void Application_UnhandledException(object sender, ApplicationUnhandledExceptionEventArgs e)
        {
            // If the app is running outside of the debugger then report the exception using
            // the browser's exception mechanism. On IE this will display it a yellow alert 
            // icon in the status bar and Firefox will display a script error.
            if (!System.Diagnostics.Debugger.IsAttached)
            {

                // NOTE: This will allow the application to continue running after an exception has been thrown
                // but not handled. 
                // For production applications this error handling should be replaced with something that will 
                // report the error to the website and stop the application.
                e.Handled = true;
                Deployment.Current.Dispatcher.BeginInvoke(delegate { ReportErrorToDOM(e); });
            }
        }

        private void ReportErrorToDOM(ApplicationUnhandledExceptionEventArgs e)
        {
            try
            {
                string errorMsg = e.ExceptionObject.Message + e.ExceptionObject.StackTrace;
                errorMsg = errorMsg.Replace('"', '\'').Replace("\r\n", @"\n");

                System.Windows.Browser.HtmlPage.Window.Eval("throw new Error(\"Unhandled Error in Silverlight Application " + errorMsg + "\");");
            }
            catch (Exception)
            {
            }
        }
    }
}
